Index: orxonox/branches/levelloader/src/track_node.h
===================================================================
--- orxonox/branches/levelloader/src/track_node.h	(revision 3605)
+++ orxonox/branches/levelloader/src/track_node.h	(revision 3605)
@@ -0,0 +1,32 @@
+/*! 
+    \file track_node.h
+    \brief Definition of the TrackNode are located here
+    
+    the TrackNode is the node, that follows the Track (and the TrackManager) 
+    through the level.
+    Under normal confitions the Plyaer(s) are 
+*/
+
+
+#ifndef _TRACK_NODE_H
+#define _TRACK_NODE_H
+
+#include "p_node.h"
+
+/* FORWARD DEFINITION */
+class TrackManager;
+
+class TrackNode : public PNode {
+
+ public:
+  TrackNode ();
+  TrackNode (Vector* absCoordinate);
+
+  virtual ~TrackNode ();
+
+ private:
+  TrackManager* trackManager;
+
+};
+
+#endif /* _TRACK_NODE_H */
Index: orxonox/branches/levelloader/src/world_entities/character_attributes.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/character_attributes.cc	(revision 3605)
+++ orxonox/branches/levelloader/src/world_entities/character_attributes.cc	(revision 3605)
@@ -0,0 +1,378 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer: ...
+*/
+
+
+#include "character_attributes.h"
+#include "stdincl.h" 
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+   \todo this constructor is not jet implemented - do it
+*/
+CharacterAttributes::CharacterAttributes () 
+{
+   this->setClassName ("CharacterAttributes");
+}
+
+
+/**
+   \brief standard deconstructor
+
+*/
+CharacterAttributes::~CharacterAttributes () 
+{
+}
+
+
+/*=====================health=====================*/
+
+/**
+   \brief sets the health of the character
+   \param helath
+ */
+void CharacterAttributes::setHealth(int health)
+{
+  this->health = health;
+}
+
+/**
+   \brief adds health to the charater
+   \param health
+   \returns health that couldnt be added due to healt limit, 0 if everything worked as normal
+ */
+int CharacterAttributes::addHealth(int health)
+{
+  this->health += health;
+  int rest = this->healthMax - this->health;
+  if( rest < 0)
+    {
+      this->health = this->healthMax;
+      return 0;
+    }
+  return rest;
+}
+
+/**
+   \brief remove health due to damager for example
+   \param amount of health
+   \returns false if health is zero -> dead
+ */
+bool CharacterAttributes::substractHealth(int health)
+{
+  this->health -= health;
+  if( this->health < 0)
+    {
+      this->health = 0;
+      return false;
+    }
+  return true;
+}
+
+/**
+   \brief gets the current amount of health
+   \returns health
+ */
+int CharacterAttributes::getHealth()
+{
+  return this->health;
+}
+
+
+/**
+   \brief sets maximum health 
+   \param health
+
+   if healthMax = 0 -> unlimited
+ */
+void CharacterAttributes::setHealthMax(int healthMax)
+{
+  this->healthMax = healthMax;
+}
+
+/**
+   \brief gets health maximium
+   \returns the health maximum
+ */
+int CharacterAttributes::getHealthMax()
+{
+  return this->healthMax;
+}
+
+
+/*======================armor/ shields===================== */
+/**
+   \brief sets the shild strength
+   \param strength
+ */
+void CharacterAttributes::setShieldStrength(int shieldStrength)
+{
+  this->shieldStrength = shieldStrength;
+}
+
+/**
+   \brief adds shield strength
+   \param strength
+   
+   there is currently no limit to shieldstrength
+ */
+void CharacterAttributes::addShieldStrength(int shiledStrength)
+{
+  this->shieldStrength += shieldStrength;
+}
+
+/**
+   \brief substracts shield strength
+   \param strength
+   \returns amount of shield strength below zero after substraction. Magic: Troumble. if everything works allright, it returns 0
+ */
+int CharacterAttributes::substractShieldStrength(int shieldStrength)
+{
+  int rest = this->shieldStrength -= shieldStrength;
+  if( rest < 0)
+    {
+      this->shieldStrength = 0;
+      return -rest;
+    }
+  return 0;
+}
+
+/**
+   \brief gets shield strength
+   \returns the shield strength
+ */
+int CharacterAttributes::getShieldStrength()
+{
+  return this->shieldStrength;
+}
+
+
+/*=====================damage=====================*/
+/**
+   \brief sets the amount of base damage dealt to all aircrafts
+   \param damage
+
+   There can be a difference between arms that hit a ground/air craft. Eg.
+   a tank will react differently to explosives than something in the air
+   (think about physics)
+ */
+void CharacterAttributes::setDamageToAirCraft(int damage)
+{
+  this->damageToAirCraft = damage;
+}
+
+/**
+   \brief gets the amount of base damage
+   \returns base damage to aircrafts
+
+   There can be a difference between arms that hit a ground/air craft. Eg.
+   a tank will react differently to explosives than something in the air
+   (think about physics)
+ */
+int CharacterAttributes::getDamageToAirCraft()
+{
+  return this->damageToAirCraft;
+}
+
+
+/**
+   \brief sets the amount of base damage dealt to all groundcrafts
+   \param damage
+
+   There can be a difference between arms that hit a ground/air craft. Eg.
+   a tank will react differently to explosives than something in the air
+   (think about physics)
+ */
+void CharacterAttributes::setDamageToGroundCraft(int damage)
+{
+  this->damageToGroundCraft = damage;
+}
+
+/**
+   \briefgets the amount of base damage
+   \returns base damage to groundcrafts
+
+   There can be a difference between arms that hit a ground/air craft. Eg.
+   a tank will react differently to explosives than something in the air
+   (think about physics)
+ */
+int CharacterAttributes::getDamageToGroundCraft()
+{
+  return this->damageToGroundCraft;
+}
+
+
+/**
+   \brief sets the damage modifier to the damage that is dealed via laser weapons
+   \param modifier [0..1]
+
+   eg. the damage is calculated after: damage = modifier * damageToGroundCraft
+ */
+void CharacterAttributes::setDamageLaserModifier(float modifier)
+{
+  this->damageLaserModifier = modifier;
+}
+
+/**
+   \brief gets the damage modifier to the damage that is dealed via laser weapons
+   \returns damage modifier
+
+   eg. the damage is calculated after: damage = modifier * damageToGroundCraft
+ */
+float CharacterAttributes::getDamageLaserModifier()
+{
+  return this->damageLaserModifier;
+}
+
+
+/**
+   \brief sets the damage modifier to the damage that is dealed via plasma weapons
+   \param damage modifier
+
+   eg. the damage is calculated after: damage = modifier * damageToGroundCraft
+ */
+void CharacterAttributes::setDamagePlasmaModifier(float modifier)
+{
+  this->damagePlasmaModifier = modifier;
+}
+
+/**
+   \brief gets the damage modifier to the damage that is dealed plasma weapons
+   \returns damage modifier
+
+   eg. the damage is calculated after: damage = modifier * damageToGroundCraft
+ */
+float CharacterAttributes::getDamagePlasmaModifier()
+{
+  return this->damagePlasmaModifier;
+}
+
+
+/**
+   \brief sets the damage modifier to the damage that is dealed via explosives
+   \param damage modifier
+
+   eg. the damage is calculated after: damage = modifier * damageToGroundCraft
+ */
+void CharacterAttributes::setDamageExplosiveModifier(float modifier)
+{
+  this->damageExplosiveModifier = modifier;
+}
+
+/**
+   \brief sets the damage modifier to the damage that is dealed via explosives
+   \returns damage modifier
+
+   eg. the damage is calculated after: damage = modifier * damageToGroundCraft
+ */
+float CharacterAttributes::getDamageExplosiveModifier()
+{
+  return this->damageExplosiveModifier;
+}
+
+
+/*=====================energy=====================*/
+/**
+   \brief sets the amount of energy 
+   \param energy
+ */
+void CharacterAttributes::setEnergy(int energy)
+{
+  this->energy = energy;
+}
+
+/**
+   \brief adds energy to the system
+   \param amount of energy
+   \returns amount of energy that is too much due to energy limit
+ */
+int CharacterAttributes::addEnergy(int addEnergy)
+{
+  this->energy += addEnergy;
+  int rest = this->energyMax - this->energy;
+  if(rest < 0)
+    {
+      this->energy = 0;
+      return rest;
+    }
+  return 0;
+}
+
+/**
+   \brief substracts energy from a system
+   \param amount of energy
+   \returns false if there is no energy anymore
+ */
+bool CharacterAttributes::substractEnergy(int subEnergy)
+{
+  this->energy -= subEnergy;
+  if(this->energy < 0)
+    {
+      this->energy = 0;
+      return false;
+    }
+  return true;
+}
+
+/**
+   \brief gets the amount of energy 
+   \returns energy
+ */
+int CharacterAttributes::getEnergy()
+{
+  return this->energy;
+}
+
+
+/**
+   \brief sets the energy consumption
+   \param amount of energy
+*/
+void CharacterAttributes::setEnergyConsumption(int energy)
+{
+  this->energyConsumption = energy;
+}
+
+/**
+   \brief gets the energy consumption
+   \returns amount of energy
+*/
+int CharacterAttributes::getEnergyConsumption()
+{
+  return this->energyConsumption;
+}
+  
+
+/**
+   \brief sets the maximum energy level
+   \param amount of energy
+*/
+void CharacterAttributes::setEnergyMax(int energy)
+{
+  this->energyMax = energy;
+}
+
+/**
+   \brief gets the max energy level
+   \returns amount of energy
+*/
+int CharacterAttributes::getEnergyMax()
+{
+  return this->energyMax;
+}
Index: orxonox/branches/levelloader/src/world_entities/character_attributes.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/character_attributes.h	(revision 3605)
+++ orxonox/branches/levelloader/src/world_entities/character_attributes.h	(revision 3605)
@@ -0,0 +1,91 @@
+/*! 
+    \file character_attributes.h
+    \brief Definition of the attributes of a character (healt, armor,.. ) whatever is important to the character
+*/
+
+#ifndef _CHARACTER_ATTRIBUTES_H
+#define _CHARACTER_ATTRIBUTES_H
+
+#include "base_object.h"
+
+
+//! A class including all important information about a character
+/**
+  its not yet clear, what the character-attributes will be. 
+*/
+class CharacterAttributes : public BaseObject {
+
+ public:
+  CharacterAttributes();
+  virtual ~CharacterAttributes();
+
+  /* health */
+  void setHealth(int health);
+  int addHealth(int health);
+  bool substractHealth(int health);
+  int getHealth();
+
+  void setHealthMax(int healthMax);
+  int getHealthMax();
+
+
+  /* armor/ shields */
+  void setShieldStrength(int shieldStrength);
+  void addShieldStrength(int shiledStrength);
+  int substractShieldStrength(int shieldStrength);
+  int getShieldStrength();
+
+
+  /* damage */
+  void setDamageToAirCraft(int damage);
+  int getDamageToAirCraft();
+
+  void setDamageToGroundCraft(int damage);
+  int getDamageToGroundCraft();
+
+  void setDamageLaserModifier(float modifier);
+  float getDamageLaserModifier();
+
+  void setDamagePlasmaModifier(float modifier);
+  float getDamagePlasmaModifier();
+
+  void setDamageExplosiveModifier(float modifier);
+  float getDamageExplosiveModifier();
+
+
+  /* energy */
+  void setEnergy(int energy);
+  int addEnergy(int addEnergy);
+  bool substractEnergy(int subEnergy);
+  int getEnergy();
+
+  void setEnergyConsumption(int energy);
+  int getEnergyConsumption();
+
+  void setEnergyMax(int energy);
+  int getEnergyMax();
+  
+
+ private:
+  /* healt */
+  int health;                        //<! the healt of a projectile
+  int healthMax;                     //<! the max healt of a projectile, =0 if no limit
+
+  /* armor/ shields */
+  int shieldStrength;                //<! the shiled strength of a character, =0 if no shields
+
+  /* damage */
+  int damageToAirCraft;              //<! damage dealt to a air craft in case of a hit
+  int damageToGroundCraft;           //<! damage dealt to a ground craft in case of a hit
+
+  float damageLaserModifier;         //<! [0..1] the damage from laser is multiplied with this modifier. there can be things in the world, that are immune to certain damage
+  float damagePlasmaModifier;        //<! [0..1] the damage from plasma is multiplied with this modifier. there can be things in the world, that are immune to certain damage
+  float damageExplosiveModifier;      //<! [0..1] the damage from exposives (rockets, tnt,...) is multiplied with this modifier. there can be things in the world, that are immune to certain damage 
+
+  /* energy */
+  int energyConsumption;             //<! if the character defines an action, it will consume energy
+  int energy;                        //<! the current amount of energy saved in this part
+  int energyMax;                     //<! the maximal energy a character can handle
+};
+
+#endif /* _CHARACTER_ATTRIBUTES_H */
Index: orxonox/branches/levelloader/src/world_entities/environment.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/environment.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/world_entities/environment.cc	(revision 3605)
@@ -100,10 +100,10 @@
 Environment::~Environment () 
 {
-  delete this->model;
+
 }
 
 void Environment::tick (float time) {}
 
-void Environment::hit (WorldEntity* weapon, Vector loc) {}
+void Environment::hit (WorldEntity* weapon, Vector* loc) {}
 
 void Environment::destroy () {}
@@ -114,5 +114,5 @@
 {
   glMatrixMode(GL_MODELVIEW);
-  glLoadIdentity();
+  glPushMatrix();
   float matrix[4][4];
   
@@ -123,4 +123,6 @@
   
   this->model->draw();
+
+  glPopMatrix();
 }
 
Index: orxonox/branches/levelloader/src/world_entities/environment.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/environment.h	(revision 3604)
+++ orxonox/branches/levelloader/src/world_entities/environment.h	(revision 3605)
@@ -9,19 +9,11 @@
   friend class World;
 
- private:
-  float xCor;
-  float yCor;
-  float zCor;
-
-  float mountainTest[10][10];
-
  public:
   Environment ();
   Environment (TiXmlElement* root);
-  ~Environment ();
-
+  virtual ~Environment ();
   
   virtual void tick (float time);
-  virtual void hit (WorldEntity* weapon, Vector loc);
+  virtual void hit (WorldEntity* weapon, Vector* loc);
   virtual void destroy ();
   virtual void collide (WorldEntity* other,  Uint32 ownhitflags, Uint32 otherhitflags);
Index: orxonox/branches/levelloader/src/world_entities/player.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/player.cc	(revision 3604)
+++ orxonox/branches/levelloader/src/world_entities/player.cc	(revision 3605)
@@ -16,8 +16,14 @@
 */
 
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_PLAYER
+
 #include "player.h"
+
 #include "stdincl.h"
 //#include "collision.h"
 #include "objModel.h"
+#include "list.h"
+#include "weapon.h"
+#include "track_manager.h"
 
 using namespace std;
@@ -31,32 +37,31 @@
 Player::Player(bool isFree) : WorldEntity(isFree)
 {
-
   this->model = new OBJModel("../data/models/reaplow.obj");
-  /*
-  objectList = glGenLists(1);
-  glNewList (objectList, GL_COMPILE);
-
-  glBegin(GL_TRIANGLES);
-  glColor3f(1,1,1);
-  glVertex3f(0,0,0.5);
-  glVertex3f(-0.5,0,-1);
-  glVertex3f(0.5,0,-1);
-
-  glVertex3f(0,0,0.5);
-  glVertex3f(0,0.5,-1);
-  glVertex3f(0,-0.5,-1);
-  glEnd();
-    
-  glBegin(GL_QUADS);
-  glColor3f(0,0,1);
-  glVertex3f(0.5,0.5,-1);
-  glVertex3f(0.5,-0.5,-1);
-  glVertex3f(-0.5,-0.5,-1);
-  glVertex3f(-0.5,0.5,-1);
-  glEnd();
-  
-  glEndList ();
-  */
-}
+  this->weapons = new tList<Weapon>();
+  this->activeWeapon = NULL;
+
+  travelSpeed = 15.0;
+  velocity = Vector();
+  bUp = bDown = bLeft = bRight = bAscend = bDescend = false;
+  bFire = false;
+  acceleration = 10.0;
+}
+
+/**
+   \brief destructs the player, deletes alocated memory
+*/
+Player::~Player ()
+{
+  Weapon* w = this->weapons->enumerate(); 
+  while( w != NULL) 
+    { 
+      delete w;
+      w = this->weapons->nextElement();
+    }
+  delete this->weapons;
+  
+  //delete this->velocity;
+}
+
 
 /**
@@ -102,10 +107,22 @@
 
 /**
-   \brief destructs the player
-*/
-Player::~Player ()
-{
-  delete this->model;
-}
+   \brief adds a weapon to the weapon list of player
+   \param weapon to add
+*/
+void Player::addWeapon(Weapon* weapon)
+{
+  this->weapons->add(weapon);
+}
+
+
+/**
+   \brief removes a weapon from the player
+   \param weapon to remove
+*/
+void Player::removeWeapon(Weapon* weapon)
+{
+  this->weapons->remove(weapon);
+}
+
 
 /**
@@ -114,21 +131,15 @@
 void Player::postSpawn ()
 {
-  travelSpeed = 15.0;
-  velocity = Vector();
-  bUp = bDown = bLeft = bRight = bAscend = bDescend = false;
-  bFire = false;
-  acceleration = 10.0;
   //setCollision(new CollisionCluster(1.0, Vector(0,0,0)));
 }
 
-/**
-   \brief the function called for each passing timeSnap
-   \param time The timespan passed since last update
-*/
-void Player::tick (float time)
-{
-  // movement
-  this->move (time);
-}
+
+/**
+   \brief the action occuring if the player left the game
+*/
+void Player::leftWorld ()
+{}
+
+
 
 /**
@@ -137,14 +148,8 @@
    \param loc ??
 */
-void Player::hit (WorldEntity* weapon, Vector loc)
-{
-}
-
-/**
-   \brief action that happens when the player is destroyed.
-*/
-void Player::destroy ()
-{
-}
+void Player::hit (WorldEntity* weapon, Vector* loc)
+{
+}
+
 
 /** 
@@ -158,19 +163,4 @@
 }
 
-/**
-   \brief The connection to the command node
-   \param cmd the Command unit from witch to map
-
-   here the commands are mapped to the players movement/weaponary
-*/
-void Player::command (Command* cmd)
-{
-  //printf("Player|recieved command [%s]\n", cmd->cmd);
-  if( !strcmp( cmd->cmd, "up")) bUp = !cmd->bUp;
-  else if( !strcmp( cmd->cmd, "down")) bDown = !cmd->bUp;
-  else if( !strcmp( cmd->cmd, "left")) bLeft = !cmd->bUp;
-  else if( !strcmp( cmd->cmd, "right")) bRight = !cmd->bUp;
-  else if( !strcmp( cmd->cmd, "fire")) bFire = !cmd->bUp;
-}
 
 /**
@@ -180,5 +170,5 @@
 { 
   glMatrixMode(GL_MODELVIEW);
-  glLoadIdentity();
+  glPushMatrix();
   float matrix[4][4];
   
@@ -191,24 +181,21 @@
   glMultMatrixf((float*)matrix);
   
-  glMatrixMode(GL_MODELVIEW);
   this->model->draw();
-  // glCallList(objectList);
-}
-
-
-/*PN
-  void Player::getLookat(Location* locbuf)
-  {
-  *locbuf = *getLocation();
-  //locbuf->dist += 5.0;
-  }
-*/
-
-/**
-   \brief the action occuring if the player left the game
-*/
-void Player::leftWorld ()
-{
-}
+  glPopMatrix();
+}
+
+
+/**
+   \brief the function called for each passing timeSnap
+   \param time The timespan passed since last update
+*/
+void Player::tick (float time)
+{
+  // player controlled movement
+  this->move (time);
+  // weapon system manipulation
+  this->fire();
+}
+
 
 /**
@@ -220,5 +207,4 @@
   Vector accel(0.0, 0.0, 0.0);
   /* FIXME: calculating the direction and orthDirection every timeSlice is redundant! save it somewhere */
-  //Placement *pos = getPlacement();
   
   /* calculate the direction in which the craft is heading  */
@@ -228,27 +214,52 @@
   //orthDirection = orthDirection.cross (direction);
 
-  if( bUp) { accel = accel+(direction*acceleration); }
-  if( bDown) { accel = accel-(direction*acceleration); }
-  if( bLeft ) { accel = accel - (orthDirection*acceleration); }
-  if( bRight ) { accel = accel + (orthDirection*acceleration); }
-  if( bAscend ) { /* not yet implemented but just: (0,0,1)*acceleration */}
-  if( bDescend) {/* FIXME */} /* \todo up and down player movement */
-
-  //Location* l = getLocation();
-  
-  // r(t) = r(0) + v(0)*t + 1/2*a*t^2
-  // r = position
-  // v = velocity
-  // a = acceleration
-
-  /* this the base-speed of the player: determines how fast and how the player follows the track*/
-  //l->dist = l->dist + travelSpeed * time;
-  
-  Vector* shift = new Vector (this->travelSpeed * time, 0, 0);
-  this->shiftCoor (shift);
-  
-  /* this updates the player position on the track - user interaction */
-  //l->pos = l->pos + accel*time;
+  if( this->bUp && this->getRelCoor().x < 20)
+    accel = accel+(direction*acceleration);
+  if( this->bDown && this->getRelCoor().x > -5)
+    accel = accel-(direction*acceleration);
+  if( this->bLeft &&  TrackManager::getInstance()->getWidth() > -this->getRelCoor().z*2)
+    accel = accel - (orthDirection*acceleration); 
+  if( this->bRight &&  TrackManager::getInstance()->getWidth() > this->getRelCoor().z*2)
+    accel = accel + (orthDirection*acceleration);
+  if( this->bAscend )
+  if( this->bDescend) {/* FIXME */} /* \todo up and down player movement */
+
   Vector move = accel * time;
   this->shiftCoor (&move);
 }
+
+
+/**
+   \brief weapon manipulation by the player
+*/
+void Player::fire()
+{
+  if(this->bFire)
+    {
+      if(this->activeWeapon != NULL)
+	this->activeWeapon->fire();
+    }
+  if(this->bWeaponChange)
+    {
+      Weapon* w = this->weapons->enumerate(); 
+      this->activeWeapon = this->weapons->nextElement(this->activeWeapon);
+    }
+}
+
+
+/**
+   \brief The connection to the command node
+   \param cmd the Command unit from witch to map
+
+   here the commands are mapped to the players movement/weaponary
+*/
+void Player::command (Command* cmd)
+{
+  PRINTF(3)("recieved command [%s]\n", cmd->cmd);
+  if( !strcmp( cmd->cmd, "up")) this->bUp = !cmd->bUp;
+  else if( !strcmp( cmd->cmd, "down")) this->bDown = !cmd->bUp;
+  else if( !strcmp( cmd->cmd, "left")) this->bLeft = !cmd->bUp;
+  else if( !strcmp( cmd->cmd, "right")) this->bRight = !cmd->bUp;
+  else if( !strcmp( cmd->cmd, "fire")) this->bFire = !cmd->bUp;
+  else if( !strcmp( cmd->cmd, "mode")) this->bWeaponChange = !cmd->bUp;
+}
Index: orxonox/branches/levelloader/src/world_entities/player.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/player.h	(revision 3604)
+++ orxonox/branches/levelloader/src/world_entities/player.h	(revision 3605)
@@ -9,5 +9,7 @@
 #include "world_entity.h"
 
+template<class T> class tList;
 class OBJModel;
+class Weapon;
 
 //! Basic controllable WorldEntity
@@ -19,17 +21,18 @@
   Player(bool isFree = false);
   Player(TiXmlElement* root);
-  ~Player();
+  virtual ~Player();
+
+  void addWeapon(Weapon* weapon);
+  void removeWeapon(Weapon* weapon);
   
   virtual void postSpawn();
-  virtual void tick(float time);
-  virtual void hit(WorldEntity* weapon, Vector loc);
-  virtual void destroy();
+  virtual void leftWorld();
+  virtual void hit(WorldEntity* weapon, Vector* loc);
   virtual void collide(WorldEntity* other, Uint32 ownhitflags, Uint32 otherhitflags);
+
+  virtual void tick(float time);  
+  virtual void draw();
+
   virtual void command(Command* cmd);
-  
-  virtual void draw();
-  // virtual void getLookat(Location* locbuf);
-  
-  virtual void leftWorld();
   
  private:
@@ -41,4 +44,8 @@
   bool bDescend;         //!< descend button presses.
   bool bFire;            //!< fire button pressed.
+  bool bWeaponChange;    //!< weapon change button pressed
+
+  tList<Weapon>* weapons;//!< a list of weapon
+  Weapon* activeWeapon;  //!< the weapon that is currenty activated
 
   Vector velocity;       //!< the velocity of the player.
@@ -47,4 +54,5 @@
   
   void move(float time);
+  void fire(void);
   
 };
Index: orxonox/branches/levelloader/src/world_entities/power_up.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/power_up.h	(revision 3604)
+++ orxonox/branches/levelloader/src/world_entities/power_up.h	(revision 3605)
@@ -15,5 +15,5 @@
  public:
   PowerUp ();
-  ~PowerUp ();
+  virtual ~PowerUp ();
   
 };
Index: orxonox/branches/levelloader/src/world_entities/primitive.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/primitive.cc	(revision 3605)
+++ orxonox/branches/levelloader/src/world_entities/primitive.cc	(revision 3605)
@@ -0,0 +1,99 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Patrick Boenzli
+   co-programmer: 
+*/
+
+
+#include "primitive.h"
+#include "stdincl.h"
+#include "world_entity.h"
+#include "vector.h"
+#include "objModel.h"
+
+using namespace std;
+
+
+
+/**
+   \brief standard constructor
+*/
+Primitive::Primitive (PRIMITIVE_FORM form) : WorldEntity()
+{
+  //this->model = new OBJModel("../data/models/fighter.obj");
+  //this->model = new OBJModel("");
+  this->object = gluNewQuadric();
+  
+  gluQuadricTexture(this->object, GL_TRUE);
+
+  this->material = new Material("Sphere");
+  this->material->setDiffuseMap("../data/pictures/load_screen.jpg");
+  this->material->setIllum(3);
+  this->material->setSpecular(1, 1, 1);
+}
+
+
+/**
+   \brief standard deconstructor
+*/
+Primitive::~Primitive () 
+{
+  delete this->material;
+  free(this->object);
+}
+
+/**
+   \brief called, when the object gets hit
+   \param other object, that hits it
+   \param location of impact
+*/
+void Primitive::hit (WorldEntity* weapon, Vector* loc) {}
+
+
+/**
+   \brief object collides
+*/
+void Primitive::collide (WorldEntity* other,  Uint32 ownhitflags, Uint32 otherhitflags) {}
+
+
+/**
+   \brief tick singal put everything here, that is timedependent
+   \param time in sec
+*/
+void Primitive::tick (float time) 
+{
+  //  Vector v(0.0, 0.0, 1.0);
+  //  Quaternion q(10.0, v);
+  //  this->setRelDir(&(this->relDirection * q));
+}
+
+/**
+   \brief drawing function of the object
+*/
+void Primitive::draw () 
+{
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+
+  float matrix[4][4];
+  glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
+  //rotate
+  //this->getAbsDir().matrix (matrix);
+  //glMultMatrixf((float*)matrix);
+  this->material->select();
+  gluSphere(this->object, 2, 20, 20);
+
+  glPopMatrix();
+}
+
Index: orxonox/branches/levelloader/src/world_entities/primitive.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/primitive.h	(revision 3605)
+++ orxonox/branches/levelloader/src/world_entities/primitive.h	(revision 3605)
@@ -0,0 +1,27 @@
+#ifndef _PRIMITIVE_H
+#define _PRIMITIVE_H
+
+#include "world_entity.h"
+
+typedef enum PRIMITIVE_FORM {PSPHERE = 0, PCUBE, PSQUARE};
+
+class Primitive : public WorldEntity 
+{
+  friend class World;
+
+ public:
+  Primitive (PRIMITIVE_FORM form);
+  virtual ~Primitive ();
+
+  virtual void tick (float time);
+  virtual void hit (WorldEntity* weapon, Vector* loc);
+  virtual void collide (WorldEntity* other,  Uint32 ownhitflags, Uint32 otherhitflags);
+  virtual void draw ();
+
+ private:
+  GLUquadricObj *object; //!< the object to be rendered
+  Material *material;    //!< A Material for the SkySphere.
+
+};
+
+#endif /* _PRIMITIVE_H */
Index: orxonox/branches/levelloader/src/world_entities/projectile.cc
===================================================================
--- orxonox/branches/levelloader/src/world_entities/projectile.cc	(revision 3605)
+++ orxonox/branches/levelloader/src/world_entities/projectile.cc	(revision 3605)
@@ -0,0 +1,82 @@
+
+
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Patrick Boenzli
+   co-programmer: 
+*/
+
+
+#include "projectile.h"
+#include "stdincl.h"
+#include "world_entity.h"
+#include "vector.h"
+#include "objModel.h"
+
+using namespace std;
+
+
+/**
+   \brief standard constructor
+*/
+Projectile::Projectile () : WorldEntity()
+{
+  this->model = new OBJModel("");
+}
+
+
+/**
+   \brief standard deconstructor
+*/
+Projectile::~Projectile () 
+{
+
+}
+
+
+/**
+   \brief signal tick, time dependent things will be handled here
+   \param time since last tick
+*/
+void Projectile::tick (float time) 
+{}
+
+/**
+   \brief the projectile gets hit by another entity
+   \param the other entity
+   \param place where it is hit
+*/
+void Projectile::hit (WorldEntity* entity, Vector* place) 
+{}
+
+
+/**
+   \brief the function gets called, when the projectile is destroyed
+*/
+void Projectile::destroy () 
+{}
+
+
+void Projectile::draw () 
+{
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+
+  float matrix[4][4];  
+  glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
+  this->getAbsDir().matrix (matrix);
+  glMultMatrixf((float*)matrix);  
+  this->model->draw();
+
+  glPopMatrix();
+}
+
Index: orxonox/branches/levelloader/src/world_entities/projectile.h
===================================================================
--- orxonox/branches/levelloader/src/world_entities/projectile.h	(revision 3605)
+++ orxonox/branches/levelloader/src/world_entities/projectile.h	(revision 3605)
@@ -0,0 +1,31 @@
+/*! 
+    \projectile.h
+    \brief a projectile, that is been shooted by a weapon
+*/
+
+#ifndef _PROJECTILE_H
+#define _PROJECTILE_H
+
+#include "world_entity.h"
+
+
+class Projectile : public WorldEntity 
+{
+  friend class World;
+
+ public:
+  Projectile ();
+  virtual ~Projectile ();
+
+  virtual void hit (WorldEntity* weapon, Vector* loc);
+  virtual void destroy ();
+
+  virtual void tick (float time);
+  virtual void draw ();
+
+ private:
+  //physical attriutes like: force, speed, acceleration etc.
+
+};
+
+#endif /* _PROJECTILE_H */
